
package EDU.bmrb.starlibj.examples;

import EDU.bmrb.starlibj.*;
import java.io.*;

public class passthru {

    static boolean demonstrate_unparse = true;
    
    public passthru () {

    }

    static public void main( String args[] ) {


	java.lang.Runtime.getRuntime().gc(); // force garbage collection.
	System.out.println( "Starting MAIN:" );
	System.out.println(
		"java.lang.Runtime.totalMemory = " +
		java.lang.Runtime.getRuntime().totalMemory() );
	System.out.println(
		"java.lang.Runtime.freeMemory =  " +
		java.lang.Runtime.getRuntime().freeMemory() );
	
	doMain( args );

	java.lang.Runtime.getRuntime().gc(); // force garbage collection.
	System.out.println( "ENDING MAIN:" );
	System.out.println(
		"java.lang.Runtime.totalMemory = " +
		java.lang.Runtime.getRuntime().totalMemory() );
	System.out.println(
		"java.lang.Runtime.freeMemory =  " +
		java.lang.Runtime.getRuntime().freeMemory() );
    }


    static public void doMain(String args[]) {

	try
	{
	    StarFileNode             sfnInput = null;
	    java.io.FileInputStream  inStream = null;
	    StarParser               myParser = null;
	    StarUnparser             myUnparser = null;
	    System.out.println("Test of the starlibj library.");
	    String                   parseFname = args[0];
	    

	    java.lang.Runtime.getRuntime().gc(); // force garbage collection.
	    System.out.println( "Starting, the memory looks like this:" );
	    System.out.println(
		    "java.lang.Runtime.totalMemory = " +
		    java.lang.Runtime.getRuntime().totalMemory() );
	    System.out.println(
		    "java.lang.Runtime.freeMemory =  " +
		    java.lang.Runtime.getRuntime().freeMemory() );
	    System.out.println(
		    "        time in milliseconds =  " +
		    System.currentTimeMillis() );

	    // read in the starting input file:
	    // --------------------------------
	    inStream =  new java.io.FileInputStream(parseFname);
	    myParser = new StarParser( inStream );
	    myParser.StarFileNodeParse(myParser);
	    sfnInput = (StarFileNode) myParser.popResult();

	    java.lang.Runtime.getRuntime().gc(); // force garbage collection.
	    System.out.println( "Parse finished. the memory looks like this:" );
	    System.out.println(
		    "java.lang.Runtime.totalMemory = " +
		    java.lang.Runtime.getRuntime().totalMemory() );
	    System.out.println(
		    "java.lang.Runtime.freeMemory =  " +
		    java.lang.Runtime.getRuntime().freeMemory() );
	    System.out.println(
		    "        time in milliseconds =  " +
		    System.currentTimeMillis() );

	    if( demonstrate_unparse )
	    {
		System.out.println( "Starting to unparse it." );
		// Ouptut the version we just read, nicely
		// ----------------------------------------------
		java.io.FileOutputStream passout1 =
			new java.io.FileOutputStream(parseFname+".1");
		myUnparser = new StarUnparser( passout1 );
		myUnparser.setFormatting( true );
		myUnparser.writeOut( sfnInput, 0 );

		passout1 = null; // Throw it away, finalizer closes file.
		sfnInput = null;
		myUnparser = null;
	    }
	    else
	    {
	        System.out.println( "SKIPPING UNPARSE STEP!" );
	    }

	    java.lang.Runtime.getRuntime().gc(); // force garbage collection.
	    System.out.println( "Finished UNparsing and Threw away everything: The memory looks like this:" );
	    System.out.println(
		    "java.lang.Runtime.totalMemory = " +
		    java.lang.Runtime.getRuntime().totalMemory() );
	    System.out.println(
		    "java.lang.Runtime.freeMemory =  " +
		    java.lang.Runtime.getRuntime().freeMemory() );
	    System.out.println(
		    "        time in milliseconds =  " +
		    System.currentTimeMillis() );

	    myParser = null;

	    java.lang.Runtime.getRuntime().gc(); // force garbage collection.
	    System.out.println( "Also Threw away parser now: The memory looks like this:" );
	    System.out.println(
		    "java.lang.Runtime.totalMemory = " +
		    java.lang.Runtime.getRuntime().totalMemory() );
	    System.out.println(
		    "java.lang.Runtime.freeMemory =  " +
		    java.lang.Runtime.getRuntime().freeMemory() );
	    System.out.println(
		    "        time in milliseconds =  " +
		    System.currentTimeMillis() );
	}
	catch( ParseException e)
	{
	    System.out.println("Parse Exception: " + e.getMessage() );
	    e.printStackTrace();
	}
	catch( FileNotFoundException e)
	{
	    System.out.println("File Not found exception opening passthru.str" );
	    e.printStackTrace();
	}
	catch( java.io.IOException e )
	{
	    System.out.println("IO exception: " + e.getMessage() );
	    e.printStackTrace();
	}

	java.lang.Runtime.getRuntime().gc(); // force garbage collection.
	System.out.println( "end of main: The memory looks like this:" );
	System.out.println(
		"java.lang.Runtime.totalMemory = " +
		java.lang.Runtime.getRuntime().totalMemory() );
	System.out.println(
		"java.lang.Runtime.freeMemory =  " +
		java.lang.Runtime.getRuntime().freeMemory() );
    }
}

